package com.lightinit.hsdataplatform.mapper;

import com.lightinit.hsdataplatform.entity.User;
import com.lightinit.hsdataplatform.entity.UserExample;
import java.util.List;

import com.lightinit.hsdataplatform.model.admin.RegisterUserStatisticsModel;
import com.lightinit.hsdataplatform.model.admin.UserCountListModel;
import com.lightinit.hsdataplatform.model.admin.UserCountSearchModel;
import com.lightinit.hsdataplatform.model.admin.UserModel;
import org.apache.ibatis.annotations.Param;

public interface UserMapper {
    long countByExample(UserExample example);

    int deleteByExample(UserExample example);

    int deleteByPrimaryKey(Long id);

    int insert(User record);

    int insertSelective(User record);

    List<User> selectByExample(UserExample example);

    User selectByPrimaryKey(Long id);

    int updateByExampleSelective(@Param("record") User record, @Param("example") UserExample example);

    int updateByExample(@Param("record") User record, @Param("example") UserExample example);

    int updateByPrimaryKeySelective(User record);

    int updateByPrimaryKey(User record);

    List<UserCountListModel> queryList(UserCountSearchModel inputModel);

    long queryCount(UserCountSearchModel inputModel);

    UserModel selectByuserId(Long userId);

    List<RegisterUserStatisticsModel> registerUserStatistics();

    List<RegisterUserStatisticsModel> registerUserGraph(@Param("year") String year);
}